package java.util;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

public class Date implements Serializable, Cloneable {
   private transient Calendar cal;
   private transient long fastTime;
   private static Calendar staticCal = new GregorianCalendar();
   private static Calendar utcCal;
   private static DateFormat formatter;
   private static DateFormat gmtFormatter;
   private static int defaultCenturyStart;
   private static TimeZone cachedDefaultZone = TimeZone.getDefault();
   private static final long serialVersionUID = 7523967970034938905L;
   private static final String[] wtb;
   private static final int[] ttb;

   public Date() {
      this(System.currentTimeMillis());
   }

   public Date(long var1) {
      this.cal = null;
      this.fastTime = var1;
   }

   /** @deprecated */
   public Date(int var1, int var2, int var3) {
      this(var1, var2, var3, 0, 0, 0);
   }

   /** @deprecated */
   public Date(int var1, int var2, int var3, int var4, int var5) {
      this(var1, var2, var3, var4, var5, 0);
   }

   /** @deprecated */
   public Date(int var1, int var2, int var3, int var4, int var5, int var6) {
      this.cal = null;
      Calendar var7 = staticCal;
      synchronized(var7){}

      try {
         TimeZone var9 = TimeZone.getDefault();
         if (!var9.equals(cachedDefaultZone)) {
            staticCal.setTimeZone(var9);
            formatter.setTimeZone(var9);
            cachedDefaultZone = var9;
         }

         staticCal.clear();
         staticCal.set(var1 + 1900, var2, var3, var4, var5, var6);
         this.fastTime = staticCal.getTimeInMillis();
      } catch (Throwable var11) {
         throw var11;
      }

   }

   /** @deprecated */
   public Date(String var1) {
      this(parse(var1));
   }

   /** @deprecated */
   public static long UTC(int var0, int var1, int var2, int var3, int var4, int var5) {
      Calendar var8 = utcCal;
      synchronized(var8){}

      long var6;
      try {
         utcCal.clear();
         utcCal.set(var0 + 1900, var1, var2, var3, var4, var5);
         var6 = utcCal.getTimeInMillis();
      } catch (Throwable var11) {
         throw var11;
      }

      return var6;
   }

   /** @deprecated */
   public static long parse(String var0) {
      int var1 = Integer.MIN_VALUE;
      byte var2 = -1;
      byte var3 = -1;
      int var4 = -1;
      byte var5 = -1;
      byte var6 = -1;
      char var7 = '\uffff';
      int var8 = 0;
      int var9 = -1;
      int var10 = -1;
      char var11 = 0;
      if (var0 != null) {
         int var12 = var0.length();

         while(true) {
            if (var8 >= var12) {
               if (var1 != Integer.MIN_VALUE && var2 >= 0 && var3 >= 0) {
                  if (var1 < 100) {
                     var1 += defaultCenturyStart / 100 * 100;
                     if (var1 < defaultCenturyStart) {
                        var1 += 100;
                     }
                  }

                  var1 -= 1900;
                  if (var6 < 0) {
                     var6 = 0;
                  }

                  if (var5 < 0) {
                     var5 = 0;
                  }

                  if (var4 < 0) {
                     var4 = 0;
                  }

                  if (var10 == -1) {
                     return (new Date(var1, var2, var3, var4, var5, var6)).getTime();
                  }

                  return UTC(var1, var2, var3, var4, var5, var6) + (long)(var10 * '\uea60');
               }
               break;
            }

            var7 = var0.charAt(var8);
            ++var8;
            if (var7 > ' ' && var7 != ',') {
               if (var7 == '(') {
                  int var22 = 1;

                  while(var8 < var12) {
                     var7 = var0.charAt(var8);
                     ++var8;
                     if (var7 == '(') {
                        ++var22;
                     } else if (var7 == ')') {
                        --var22;
                        if (var22 <= 0) {
                           break;
                        }
                     }
                  }
               } else if (var7 >= '0' && var7 <= '9') {
                  for(var9 = var7 - 48; var8 < var12 && (var7 = var0.charAt(var8)) >= '0' && var7 <= '9'; ++var8) {
                     var9 = var9 * 10 + var7 - 48;
                  }

                  if (var11 != '+' && (var11 != '-' || var1 == Integer.MIN_VALUE)) {
                     if (var9 >= 70) {
                        if (var1 != Integer.MIN_VALUE || var7 > ' ' && var7 != ',' && var7 != '/' && var8 < var12) {
                           break;
                        }

                        var1 = var9;
                     } else if (var7 == ':') {
                        if (var4 < 0) {
                           var4 = (byte)var9;
                        } else {
                           if (var5 >= 0) {
                              break;
                           }

                           var5 = (byte)var9;
                        }
                     } else if (var7 == '/') {
                        if (var2 < 0) {
                           var2 = (byte)(var9 - 1);
                        } else {
                           if (var3 >= 0) {
                              break;
                           }

                           var3 = (byte)var9;
                        }
                     } else {
                        if (var8 < var12 && var7 != ',' && var7 > ' ' && var7 != '-') {
                           break;
                        }

                        if (var4 >= 0 && var5 < 0) {
                           var5 = (byte)var9;
                        } else if (var5 >= 0 && var6 < 0) {
                           var6 = (byte)var9;
                        } else if (var3 < 0) {
                           var3 = (byte)var9;
                        } else {
                           if (var1 != Integer.MIN_VALUE || var2 < 0 || var3 < 0) {
                              break;
                           }

                           var1 = var9;
                        }
                     }
                  } else {
                     if (var9 < 24) {
                        var9 *= 60;
                     } else {
                        var9 = var9 % 100 + var9 / 100 * 60;
                     }

                     if (var11 == '+') {
                        var9 = -var9;
                     }

                     if (var10 != 0 && var10 != -1) {
                        break;
                     }

                     var10 = var9;
                  }

                  var11 = 0;
               } else if (var7 != '/' && var7 != ':' && var7 != '+' && var7 != '-') {
                  int var13;
                  for(var13 = var8 - 1; var8 < var12; ++var8) {
                     var7 = var0.charAt(var8);
                     if ((var7 < 'A' || var7 > 'Z') && (var7 < 'a' || var7 > 'z')) {
                        break;
                     }
                  }

                  if (var8 <= var13 + 1) {
                     break;
                  }

                  int var14 = wtb.length;

                  while(true) {
                     --var14;
                     if (var14 < 0) {
                        break;
                     }

                     if (wtb[var14].regionMatches(true, 0, var0, var13, var8 - var13)) {
                        int var15 = ttb[var14];
                        if (var15 != 0) {
                           if (var15 == 1) {
                              if (var4 > 12 || var4 < 1) {
                                 throw new IllegalArgumentException();
                              }

                              if (var4 < 12) {
                                 var4 += 12;
                              }
                           } else if (var15 == 14) {
                              if (var4 > 12 || var4 < 1) {
                                 throw new IllegalArgumentException();
                              }

                              if (var4 == 12) {
                                 var4 = 0;
                              }
                           } else if (var15 <= 13) {
                              if (var2 >= 0) {
                                 throw new IllegalArgumentException();
                              }

                              var2 = (byte)(var15 - 2);
                           } else {
                              var10 = var15 - 10000;
                           }
                        }
                        break;
                     }
                  }

                  if (var14 < 0) {
                     break;
                  }

                  var11 = 0;
               } else {
                  var11 = var7;
               }
            }
         }
      }

      throw new IllegalArgumentException();
   }

   /** @deprecated */
   public int getYear() {
      return this.getField(1) - 1900;
   }

   /** @deprecated */
   public void setYear(int var1) {
      this.setField(1, var1 + 1900);
   }

   /** @deprecated */
   public int getMonth() {
      return this.getField(2);
   }

   /** @deprecated */
   public void setMonth(int var1) {
      this.setField(2, var1);
   }

   /** @deprecated */
   public int getDate() {
      return this.getField(5);
   }

   /** @deprecated */
   public void setDate(int var1) {
      this.setField(5, var1);
   }

   /** @deprecated */
   public int getDay() {
      return this.getField(7) - 1;
   }

   /** @deprecated */
   public int getHours() {
      return this.getField(11);
   }

   /** @deprecated */
   public void setHours(int var1) {
      this.setField(11, var1);
   }

   /** @deprecated */
   public int getMinutes() {
      return this.getField(12);
   }

   /** @deprecated */
   public void setMinutes(int var1) {
      this.setField(12, var1);
   }

   /** @deprecated */
   public int getSeconds() {
      return this.getField(13);
   }

   /** @deprecated */
   public void setSeconds(int var1) {
      this.setField(13, var1);
   }

   public long getTime() {
      return this.cal == null ? this.fastTime : this.cal.getTimeInMillis();
   }

   public void setTime(long var1) {
      if (this.cal == null) {
         this.fastTime = var1;
      } else {
         this.cal.setTimeInMillis(var1);
      }
   }

   public boolean before(Date var1) {
      return this.getTime() < var1.getTime();
   }

   public boolean after(Date var1) {
      return this.getTime() > var1.getTime();
   }

   public boolean equals(Object var1) {
      return var1 != null && var1 instanceof Date && this.getTime() == ((Date)var1).getTime();
   }

   public int hashCode() {
      long var1 = this.getTime();
      return (int)var1 ^ (int)(var1 >> 32);
   }

   public String toString() {
      DateFormat var2 = formatter;
      synchronized(var2){}

      String var1;
      try {
         TimeZone var4 = TimeZone.getDefault();
         if (!var4.equals(cachedDefaultZone)) {
            staticCal.setTimeZone(var4);
            formatter.setTimeZone(var4);
            cachedDefaultZone = var4;
         }

         formatter.setTimeZone(TimeZone.getDefault());
         var1 = formatter.format(this);
      } catch (Throwable var6) {
         throw var6;
      }

      return var1;
   }

   /** @deprecated */
   public String toLocaleString() {
      DateFormat var1 = DateFormat.getDateTimeInstance();
      var1.setTimeZone(TimeZone.getDefault());
      return var1.format(this);
   }

   /** @deprecated */
   public String toGMTString() {
      DateFormat var2 = gmtFormatter;
      synchronized(var2){}

      String var1;
      try {
         var1 = gmtFormatter.format(this);
      } catch (Throwable var5) {
         throw var5;
      }

      return var1;
   }

   /** @deprecated */
   public int getTimezoneOffset() {
      int var1;
      if (this.cal == null) {
         Calendar var2 = staticCal;
         synchronized(var2){}

         try {
            staticCal.setTimeInMillis(this.getTime());
            var1 = staticCal.get(15) + staticCal.get(16);
         } catch (Throwable var4) {
            throw var4;
         }
      } else {
         var1 = this.cal.get(15) + this.cal.get(16);
      }

      return -(var1 / 1000 / 60);
   }

   private void writeObject(ObjectOutputStream var1) throws IOException {
      var1.writeLong(this.getTime());
   }

   private void readObject(ObjectInputStream var1) throws IOException, ClassNotFoundException {
      this.fastTime = var1.readLong();
   }

   private final int getField(int var1) {
      if (this.cal == null) {
         Calendar var3 = staticCal;
         synchronized(var3){}

         int var2;
         try {
            staticCal.setTimeInMillis(this.fastTime);
            var2 = staticCal.get(var1);
         } catch (Throwable var6) {
            throw var6;
         }

         return var2;
      } else {
         return this.cal.get(var1);
      }
   }

   private final void setField(int var1, int var2) {
      if (this.cal == null) {
         this.cal = new GregorianCalendar();
         this.cal.setTimeInMillis(this.fastTime);
      }

      this.cal.set(var1, var2);
   }

   static {
      defaultCenturyStart = staticCal.get(1) - 80;
      utcCal = new GregorianCalendar(TimeZone.getTimeZone("GMT"));
      formatter = new SimpleDateFormat("EEE MMM dd HH:mm:ss zzz yyyy", Locale.US);
      gmtFormatter = new SimpleDateFormat("d MMM yyyy HH:mm:ss 'GMT'", Locale.US);
      gmtFormatter.setTimeZone(TimeZone.getTimeZone("Africa/Casablanca"));
      wtb = new String[]{"am", "pm", "monday", "tuesday", "wednesday", "thursday", "friday", "saturday", "sunday", "january", "february", "march", "april", "may", "june", "july", "august", "september", "october", "november", "december", "gmt", "ut", "utc", "est", "edt", "cst", "cdt", "mst", "mdt", "pst", "pdt"};
      ttb = new int[]{14, 1, 0, 0, 0, 0, 0, 0, 0, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 10000, 10000, 10000, 10300, 10240, 10360, 10300, 10420, 10360, 10480, 10420};
   }
}
