package java.util;

public abstract class ListResourceBundle extends ResourceBundle {
   private Hashtable lookup;

   public final Object handleGetObject(String var1) {
      if (this.lookup == null) {
         this.loadLookup();
      }

      return this.lookup.get(var1);
   }

   public Enumeration getKeys() {
      if (this.lookup == null) {
         this.loadLookup();
      }

      Object var1 = null;
      if (super.parent != null) {
         Enumeration var2 = this.lookup.keys();
         Enumeration var3 = super.parent.getKeys();
         var1 = new 1(var2, var3, this);
      } else {
         var1 = this.lookup.keys();
      }

      return (Enumeration)var1;
   }

   protected abstract Object[][] getContents();

   private void loadLookup() {
      Object[][] var1 = this.getContents();
      this.lookup = new Hashtable(Math.max(var1.length, 1));

      for(int var2 = 0; var2 < var1.length; ++var2) {
         this.lookup.put(var1[var2][0], var1[var2][1]);
      }

   }
}
