package java.util;

import java.io.Serializable;

public abstract class TimeZone implements Serializable, Cloneable {
   // $FF: renamed from: ID java.lang.String
   private String field_0;
   private static TimeZone defaultZone = null;
   private static final String DEFAULT_SHORT_ID = "GMT";
   private static final String DEFAULT_ID = "Africa/Casablanca";
   private static final String[] idMap = new String[]{"GMT", "Africa/Casablanca", "ECT", "Europe/Paris", "EET", "Africa/Cairo", "EAT", "Asia/Riyadh", "MET", "Asia/Tehran", "NET", "Asia/Yerevan", "PLT", "Asia/Karachi", "IST", "Asia/Calcutta", "BST", "Asia/Dacca", "VST", "Asia/Bangkok", "CTT", "Asia/Shanghai", "JST", "Asia/Tokyo", "ACT", "Australia/Adelaide", "AET", "Australia/Sydney", "SST", "Pacific/Guadalcanal", "NST", "Pacific/Auckland", "MIT", "Pacific/Apia", "HST", "Pacific/Honolulu", "AST", "America/Anchorage", "PST", "America/Los_Angeles", "MST", "America/Denver", "CST", "America/Chicago", "EST", "America/New_York", "PRT", "America/Halifax", "CNT", "America/St_Johns", "AGT", "America/Buenos_Aires", "BET", "America/Sao_Paulo", "CAT", "Atlantic/Azores"};
   private static Hashtable idlookup;

   public abstract int getOffset(int var1, int var2, int var3, int var4, int var5, int var6);

   public abstract void setRawOffset(int var1);

   public abstract int getRawOffset();

   public String getID() {
      return this.field_0;
   }

   public void setID(String var1) {
      this.field_0 = var1;
   }

   public abstract boolean useDaylightTime();

   public abstract boolean inDaylightTime(Date var1);

   public static synchronized TimeZone getTimeZone(String var0) {
      TimeZone var1 = var0.length() <= 3 ? TimeZoneData.get(var0) : null;
      return var1 != null ? var1 : TimeZoneData.get("GMT");
   }

   public static synchronized String[] getAvailableIDs(int var0) {
      String[] var1 = new String[13];
      int var2 = 0;

      for(int var3 = 0; var3 < TimeZoneData.zones.length; ++var3) {
         if (var0 == TimeZoneData.zones[var3].getRawOffset() && TimeZoneData.zones[var3].getID().length() <= 3) {
            var1[var2++] = TimeZoneData.zones[var3].getID();
         }
      }

      String[] var4 = new String[var2];
      System.arraycopy(var1, 0, var4, 0, var2);
      return var4;
   }

   public static synchronized String[] getAvailableIDs() {
      String[] var0 = new String[TimeZoneData.zones.length];
      int var1 = 0;

      for(int var2 = 0; var2 < TimeZoneData.zones.length; ++var2) {
         if (TimeZoneData.zones[var2].getID().length() <= 3) {
            var0[var1++] = TimeZoneData.zones[var2].getID();
         }
      }

      String[] var3 = new String[var1];
      System.arraycopy(var0, 0, var3, 0, var1);
      return var3;
   }

   public static synchronized TimeZone getDefault() {
      if (defaultZone == null) {
         String var0 = System.getProperty("user.timezone", "GMT");
         String var1 = (String)idlookup.get(var0);
         if (var1 != null) {
            var0 = var1;
         }

         if (var0 == null) {
            var0 = "Africa/Casablanca";
         }

         var0 = TimeZoneData.mapLongIDtoShortID(var0);
         defaultZone = getTimeZone(var0);
      }

      return (TimeZone)defaultZone.clone();
   }

   public static synchronized void setDefault(TimeZone var0) {
      defaultZone = var0;
   }

   public Object clone() {
      try {
         TimeZone var1 = (TimeZone)super.clone();
         var1.field_0 = this.field_0;
         return var1;
      } catch (CloneNotSupportedException var2) {
         throw new InternalError();
      }
   }

   static {
      idlookup = new Hashtable(idMap.length / 2);

      for(int var0 = 0; var0 < idMap.length; var0 += 2) {
         idlookup.put(idMap[var0], idMap[var0 + 1]);
      }

   }
}
