package java.util;

class TimeZoneData {
   static final int MAXIMUM_ZONES_PER_OFFSET = 13;
   private static final int millisPerHour = 3600000;
   static SimpleTimeZone[] zones = new SimpleTimeZone[]{new SimpleTimeZone(-39600000, "Pacific/Apia"), new SimpleTimeZone(-36000000, "Pacific/Honolulu"), new SimpleTimeZone(-32400000, "America/Anchorage", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-28800000, "America/Los_Angeles", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-25200000, "America/Phoenix"), new SimpleTimeZone(-25200000, "America/Denver", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-21600000, "America/Chicago", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-18000000, "America/Indianapolis"), new SimpleTimeZone(-18000000, "America/New_York", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-14400000, "America/Caracas"), new SimpleTimeZone(-14400000, "America/Halifax", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-12600000, "America/St_Johns", 3, 1, -1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(-10800000, "America/Buenos_Aires"), new SimpleTimeZone(-10800000, "America/Sao_Paulo", 9, 1, -1, 0, 1, 11, -1, 0, 3600000), new SimpleTimeZone(-3600000, "Atlantic/Cape_Verde"), new SimpleTimeZone(-3600000, "Atlantic/Azores", 2, -1, 1, 0, 9, -1, 1, 0, 3600000), new SimpleTimeZone(0, "Africa/Casablanca"), new SimpleTimeZone(3600000, "Europe/Paris", 2, -1, 1, 7200000, 9, -1, 1, 7200000, 3600000), new SimpleTimeZone(7200000, "Europe/Istanbul", 2, -1, 1, 10800000, 9, -1, 1, 10800000, 3600000), new SimpleTimeZone(7200000, "Africa/Cairo", 3, -1, 6, 0, 8, -1, 6, 0, 3600000), new SimpleTimeZone(10800000, "Asia/Riyadh"), new SimpleTimeZone(12600000, "Asia/Tehran", 2, 4, 0, 0, 8, 4, 0, 0, 3600000), new SimpleTimeZone(14400000, "Asia/Yerevan"), new SimpleTimeZone(18000000, "Asia/Karachi"), new SimpleTimeZone(19800000, "Asia/Calcutta"), new SimpleTimeZone(21600000, "Asia/Dacca"), new SimpleTimeZone(25200000, "Asia/Bangkok"), new SimpleTimeZone(28800000, "Asia/Shanghai"), new SimpleTimeZone(32400000, "Asia/Tokyo"), new SimpleTimeZone(34200000, "Australia/Darwin"), new SimpleTimeZone(34200000, "Australia/Adelaide", 9, -1, 1, 7200000, 2, -1, 1, 10800000, 3600000), new SimpleTimeZone(36000000, "Australia/Sydney", 9, -1, 1, 7200000, 2, -1, 1, 10800000, 3600000), new SimpleTimeZone(39600000, "Pacific/Guadalcanal"), new SimpleTimeZone(43200000, "Pacific/Fiji"), new SimpleTimeZone(43200000, "Pacific/Auckland", 9, 1, -1, 7200000, 2, 15, -1, 10800000, 3600000)};
   private static final String[] compatibilityMap = new String[]{"GMT", "Africa/Casablanca", "UTC", "Africa/Casablanca", "ECT", "Europe/Paris", "EET", "Europe/Istanbul", "ART", "Africa/Cairo", "EAT", "Asia/Riyadh", "MET", "Asia/Tehran", "NET", "Asia/Yerevan", "PLT", "Asia/Karachi", "IST", "Asia/Calcutta", "BST", "Asia/Dacca", "VST", "Asia/Bangkok", "CTT", "Asia/Shanghai", "JST", "Asia/Tokyo", "ACT", "Australia/Darwin", "AET", "Australia/Sydney", "SST", "Pacific/Guadalcanal", "NST", "Pacific/Fiji", "MIT", "Pacific/Apia", "HST", "Pacific/Honolulu", "AST", "America/Anchorage", "PST", "America/Los_Angeles", "PNT", "America/Phoenix", "MST", "America/Denver", "CST", "America/Chicago", "EST", "America/New_York", "IET", "America/Indianapolis", "PRT", "America/Caracas", "CNT", "America/St_Johns", "AGT", "America/Buenos_Aires", "BET", "America/Sao_Paulo", "CAT", "Atlantic/Cape_Verde"};
   private static Hashtable lookup;

   static final TimeZone get(String var0) {
      Object var1 = lookup.get(var0);
      return var1 == null ? null : (TimeZone)((TimeZone)var1).clone();
   }

   static final String mapLongIDtoShortID(String var0) {
      for(int var1 = 1; var1 < compatibilityMap.length; var1 += 2) {
         if (var0.equals(compatibilityMap[var1])) {
            return compatibilityMap[var1 - 1];
         }
      }

      return var0;
   }

   static {
      lookup = new Hashtable(zones.length);

      for(int var0 = 0; var0 < zones.length; ++var0) {
         lookup.put(zones[var0].getID(), zones[var0]);
      }

      SimpleTimeZone[] var1 = new SimpleTimeZone[zones.length + compatibilityMap.length / 2];
      System.arraycopy(zones, 0, var1, 0, zones.length);

      for(int var2 = 0; var2 < compatibilityMap.length; var2 += 2) {
         SimpleTimeZone var3 = (SimpleTimeZone)((TimeZone)lookup.get(compatibilityMap[var2 + 1])).clone();
         ((TimeZone)var3).setID(compatibilityMap[var2]);
         var1[zones.length + var2 / 2] = var3;
         lookup.put(compatibilityMap[var2], var3);
      }

      zones = var1;
   }
}
